<?php
/*
 * @version $Id$
 * @package Joomleague
 * @subpackage playerbot
 * @copyright Copyright (C) 2007  JoomLeague
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see _joomleague_license.txt
 
**********************************************
JoomLeague JOOMLEAGUE PLAYER BOT
Copyright (c) 2008 JoomLeague.de
**********************************************
This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This header must not be removed. Additional contributions/changes
may be added to this header as long as no information is deleted.
**********************************************

* JOOMLEAGUE PLAYER BOT
*
* 2008-03-10 - Version 0.93
*
* Links player names in content with joomleague player details
*

**********************************************
Get the latest version of JoomLeague at:
http://www.joomleague.de//
**********************************************
*/

defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');
/*****

if (file_exists($mosConfig_absolute_path .
    '/components/com_joomleague/language/' . $mosConfig_lang . '.php')) {
    include_once ($mosConfig_absolute_path . '/components/com_joomleague/language/' .
        $mosConfig_lang . '.php');
} else {
    include_once ($mosConfig_absolute_path .
        '/components/com_joomleague/language/english.php');
}
require_once 'administrator/components/com_joomleague/joomleague.class.php';

*****/

// register mambot function
$_MAMBOTS->registerFunction('onPrepareContent', 'bot_joomleague_player');

// function definition
function bot_joomleague_player($published, &$row, &$params, $page = 0)
{
    global $my;
    
    if (!$published) {
        $row->text = preg_replace("#{jl_player}(.*?){/jl_player}#s", "", $row->text);
        return;
    }

    global $database, $Itemid;

    // search for bot tag
    if (preg_match_all("#{jl_player}(.*?){/jl_player}#s", $row->text, $matches,
        PREG_PATTERN_ORDER) > 0) {
        // loop throuh found matches

        foreach ($matches[0] as $match) {
        	
			$name = preg_replace("/{.+?}/", "", $match);        	

            // get first and last name
            $aname = split(" ", html_entity_decode($name) );
            $firstname = $aname[0];
            $lastname = $aname[1];


            //build query to select player id
            $query = "SELECT pt.id, pt.player_id, pt.project_id
		            FROM #__joomleague_playertool pt
		       INNER JOIN #__joomleague_players pl ON pl.id = pt.player_id
		       INNER JOIN #__joomleague_teams t ON pt.team_id = t.id
		       INNER JOIN #__joomleague_team_joomleague tt ON tt.team_id = t.id AND tt.project_id = pt.project_id
		       INNER JOIN #__joomleague p ON pt.project_id = p.id
		       INNER JOIN #__joomleague_seasons s ON s.id = p.season_id
		       INNER JOIN #__joomleague_leagues l ON l.id = p.league_id
			       WHERE pl.firstname = '$firstname' AND
				         pl.lastname = '$lastname' AND
				         p.published = 1
                ORDER BY s.ordering, l.ordering, pt.id DESC";


            // run query
            $database->setQuery($query);
            $rows = $database->loadObjectList();
            
            if ( $database->getErrorNum() && $my->gid > 2 ) {
              echo $database->getErrorMsg();
            }
            // get result
            // replace only if project id set
            if (isset($rows[0]->project_id)) {
                $pt_id = $rows[0]->id;
                $pl_id = $rows[0]->player_id;
                $project_id = $rows[0]->project_id;
                $link = '<a href = "' . sefRelToAbs("index.php?option=com_joomleague&amp;func=showPlayer&amp;p=$project_id&amp;pid=$pl_id&amp;Itemid=$Itemid") . '">';
								
                $row->text = preg_replace("#{jl_player}" . $name . "{/jl_player}#s", $link . $name .
                    "</a>", $row->text);
            } 
            else {
              $row->text = preg_replace("#{jl_player}" . $name . "{/jl_player}#s", $name, $row->text);
            }
        }
    }
}
?>
