<?php 
/*
 * @version $Id$
 * @package Joomleague
 * @subpackage ranking
 * @copyright Copyright (C) 2007  JoomLeague
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see _joomleague_license.txt
**********************************************
JoomLeague RANKING MODULE
Copyright (c) 2007 JoomLeague.de
**********************************************
This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This header must not be removed. Additional contributions/changes
may be added to this header as long as no information is deleted.
**********************************************

* RANKING MODULE
*
* 2008-01-08 - Version 0.92
*
* Displays the the actual ranking of the given project.
* There are some options for this module, which can be set in the 
* "Parameters" section of the module in Administration.
*

**********************************************
Get the latest version of JoomLeague at:
http://www.joomleague.de//
**********************************************
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

if (file_exists($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php')) {
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php');
} 
else {
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/english.php');
}

require_once ($mosConfig_absolute_path.'/administrator/components/com_joomleague/joomleague.class.php');
require_once ($mosConfig_absolute_path.'/components/com_joomleague/js/joomleague_tabs.js.php');?>

<!-- To remain XHTML compatibility move this stylesheet link to the head of your index.php -->
<link rel="stylesheet" type="text/css" href="<?php echo $mosConfig_live_site;?>/components/com_joomleague/css/joomleague_tabs.css" />
<!-- Stylesheet link END -->

<script language="javascript" type="text/javascript">
<!-- // --><![CDATA[ 
var dhtml_ranking<?php echo $module->id; ?> = new mosDHTML();
// ]]></script>

<?php
#comment this line for mambo version < 4.5.1
$params10x = mosParseParams( $module->params );

// get project from setup, or from url if not specified
$project = new JoomLeague( $database );
if ($params10x->project) {
 $project_id = $params10x->project;
}
else {
 $project_id = intval(mosGetParam($_REQUEST, 'p', 0));
}
$project->load($project_id);

if ($project->id) {
  // get parameters
  $max_team = intval($params10x->showteams); //default "all" => 0
  $table_config=$project->getTemplateConfig("show_table.tpl");
  $colors = $project->getColors($table_config['colors']);
  
  // prepare ranking object
  $joomleague_ranking = & new Ranking();
  $joomleague_ranking->setProjectConfig($project, $table_config['rankingorder']);
  
  // tabs management
  $counttabs=0;
  $temprank='';
  if($params10x->show_multiple_rankings == 0) {
    $divtext[$counttabs]='';
    $starttabs[$counttabs]=0;
    $tabsmod[$counttabs]=0;
    $counttabs++;
  } 
  else {
    if($params10x->show_multiple_rankings == 1 && $params10x->show_ranking_home == 1){
      $divtext[$counttabs]='<div id="page_ranking_home'.$module->id.'" class="pagetext">';
      $tabsmod[$counttabs]=1;
      $counttabs++;
    }
    if($params10x->show_multiple_rankings == 1 && $params10x->show_ranking_all == 1){
      $divtext[$counttabs]='<div id="page_ranking_all'.$module->id.'" class="pagetext">';
      $tabsmod[$counttabs]=0;
      $counttabs++;
    }
    if($params10x->show_multiple_rankings == 1 && $params10x->show_ranking_away == 1){
      $divtext[$counttabs]='<div id="page_ranking_away'.$module->id.'" class="pagetext">';
      $tabsmod[$counttabs]=2;
      $counttabs++;
    }
  }
  
  ?>
  
  <?php if($params10x->show > 0){?><div align="center"><b><?php echo $project->name;?></b></div><?php }?>
  
  <?php
    if($params10x->show_multiple_rankings == 1){
      echo '<table cellspacing="0" cellpadding="1" border="0" width="100%"><tr align="center">';
      if($params10x->show_ranking_home == 1){echo '<td width="33%" id="tab_ranking_home'.$module->id.'" class="offtab" onclick="dhtml_ranking'.$module->id.'.cycleTab(this.id)">'._JL_MODULE_RANKING_HOME.'</td>';}
      if($params10x->show_ranking_all == 1){echo '<td width="34%" id="tab_ranking_all'.$module->id.'" class="offtab" onclick="dhtml_ranking'.$module->id.'.cycleTab(this.id)">'._JL_MODULE_RANKING_OVERALL.'</td>';}       
      if($params10x->show_ranking_away == 1){echo '<td width="33%" id="tab_ranking_away'.$module->id.'" class="offtab" onclick="dhtml_ranking'.$module->id.'.cycleTab(this.id)">'._JL_MODULE_RANKING_AWAY.'</td>';}
      echo '</tr></table>';
    }
  ?>
  
  <?php
  for( $i=0 ; $i<$counttabs ; $i++ ) {
    if ($divtext[$i]<>'') echo $divtext[$i];
    
    //  Normal Ranking without tabs START    
    //  start table
    echo '<table width="100%" align="center" border="0" cellpadding="2" cellspacing="0">';
    
    $col_count = 1;
    
    // header row
    echo '<tr class="sectiontableheader">';
    echo '<td align="center">&nbsp;</td>';
    echo '<td align="center">&nbsp;</td>';
    if($params10x->show_logo_small_table){echo '<td align="center">&nbsp;</td>';$col_count++;}
    if($params10x->show_cnt_matches){echo '<td align="center"><b>'._JL_MODULE_RANKING_PLAYED.'</b></td>';$col_count++;}
    if($params10x->show_won){echo '<td align="center"><b>'._JL_TABLE_WON.'</b></td>';$col_count++;}
    if($params10x->show_draw){echo '<td align="center"><b>'._JL_TABLE_DRAW.'</b></td>';$col_count++;}
    if($params10x->show_loss){echo '<td align="center"><b>'._JL_TABLE_LOSS.'</b></td>';$col_count++;}
    if($params10x->show_results){echo '<td align="center"><b>'._JL_MODULE_RANKING_FOR_AGAINST.'</b></td>';$col_count++;}
    if($params10x->show_diff){echo '<td align="center"><b>'._JL_MODULE_RANKING_DIFF.'</b></td>';$col_count++;}
    if($params10x->show_points){echo '<td align="center"><b>'._JL_MODULE_RANKING_POINTS.'</b></td>';$col_count++;}
    echo '</tr>';
    
    //generate ranking
    $table = $joomleague_ranking->getRanking($tabsmod[$i],$project->current_round, 1, $table_config['show_negative_points'], $table_config['sort_table'], $params10x->division);
    //if ($tabsmod[$i]==0) {print_r($table);exit;}
    $counter=1; $k = 0; $j = 0; $displayed_favs=0;
    
    // retrieve favteams if display was selected
    if ( $params10x->show_favs ) {
      // use fav_team from cookie if exist
      if (isset($_COOKIE['joomleague_user_fav_team_p_'.$project->id.''])) $favteam=explode(",", $_COOKIE['joomleague_user_fav_team_p_'.$project->id.'']);
      
      // use fav_team from tip_members table if no cookie exist and user is logged in
      if (!isset($_COOKIE['joomleague_user_fav_team_p_'.$project->id.'']) && $my->id > 0) {
        $query = sprintf("SELECT fav_team FROM #__joomleague_tip_members WHERE user_id = %s AND project_id = %s", $my->id, $project->id);
        $project->_db->setQuery($query);
        $user_db_fav_team = $project->_db->loadResult();
        
        $query = sprintf("SELECT team_id FROM #__joomleague_team_joomleague WHERE id = %s AND project_id = %s", $user_db_fav_team, $project->id);
        $project->_db->setQuery($query);
        $user_db_favteam = $project->_db->loadResult();
        $favteam=explode(",", $user_db_favteam);
      }
      
      // use fav_team from project configuration if no cookie exist and user is not logged in  
      if (!isset($_COOKIE['joomleague_user_fav_team_p_'.$project->id.'']) && $my->id == 0) $favteam=explode(",", $project->fav_team);
    }
    else $favteam= array();
    
    foreach($table as $item) {
      // check if max teams was reached
      if ( $max_team && $counter > $max_team
            && ( $params10x->show_favs==0 || $displayed_favs >= count($favteam) ) ) { 
        break; //max team was reached and no more favorites teams to display, exit loop
      }
      
      //class for row display
      $class = ($k == 0)? $params10x->sectiontableentry1 : $params10x->sectiontableentry2;         
      
      //colors
      if($params10x->highlight == 1){
        $color = "";
        if($counter >= $colors[$j]["from"] && $counter <= $colors[$j]["to"]) $color = $colors[$j]["color"];
        if($counter == $colors[$j]["to"]) $j++;
      }  
      else $color = "";
          
      if ( ( $params10x->show_favs && in_array($item->team->id, $favteam) )
            || $counter<=$max_team 
            || !$max_team ) {
        
        //name type    
        if($params10x->names == "0") $nametype = $item->team->short_name;
        if($params10x->names == "1") $nametype = $item->team->middle_name;
        if($params10x->names == "2") $nametype = $item->team->name;
        
        //club
        $club_id = $item->team->club_id;
        //logo
        $small_club_icon = $item->team->logo_small;
        //website
        $website = $item->team->website;
        //team
        $team_id = $item->team->teamtoolid;
        
        $format = "%s";
        if ( $params10x->fav_team_bold == 1 && in_array($item->team->id, $favteam) ) {$format = "<b>%s</b>";}
        if ( in_array($item->team->id, $favteam) ) $displayed_favs++;
    
        // start ranking row    
        echo '<tr class="'.$class.'">';
        
        //rank
        echo '<td bgcolor="'.$color.'" align="right">'; 
        if (($item->rank!=$temprank) || ($counter==1)) printf($format, $item->rank);
        else echo "-"; 
        echo '&nbsp;</td>';
        
        //logo
        if ($params10x->show_logo_small_table) {
          echo '<td valign="top" bgcolor="'.$color.'" align="center">
                <img src="'.$mosConfig_live_site.'/'.$small_club_icon.'" alt="'.$nametype.'" title="'.$nametype.'" align="middle" border="0"/>
                </td>';
        }
      
        //name
        echo '<td bgcolor="'.$color.'" align="left" nowrap="nowrap">';
        if ($params10x->link_team_to == 0){
          printf($format, $nametype); 
          echo '</td>';
        }    
        //or name linked to showPlayers
        else if ($params10x->link_team_to == 1) {
          echo '<a href="'.sefRelToAbs('index.php?option=com_joomleague&amp;func=showPlayers&amp;p='.$project->id.'&amp;ttid='.$team_id.'&amp;Itemid='.$Itemid).'">';
          printf($format, $nametype); 
          echo '</a></td>';
        }
        //or name linked to showClubInfo     
        else if ($params10x->link_team_to == 2) {
          echo '<a href="'.sefRelToAbs('index.php?option=com_joomleague&amp;func=showClubInfo&amp;p='.$project->id.'&amp;cid='.$club_id.'&amp;Itemid='.$Itemid).'">';
          printf($format, $nametype); 
          echo '</a></td>';
        }
        //or name linked to website
        else if ($params10x->link_team_to == 3) {
          if ( $website != "" ) echo '<a href="'.$website.'" target="_blank" >';
          printf($format, $nametype); 
          if ( $website != "" ) echo '</a></td>';
        }
        //or name linked to team info
        else if ($params10x->link_team_to == 4) {
          echo '<a href="'.sefRelToAbs('index.php?option=com_joomleague&amp;func=showTeamInfo&amp;p='.$project->id.'&amp;tid='.$item->team->id.'&amp;Itemid='.$Itemid).'">';
          printf($format, $nametype); 
          echo '</a></td>';
        }
          
        if($params10x->show_cnt_matches) {
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->cnt_matches); 
          echo '</td>';
        }
        if($params10x->show_won) {
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->cnt_won); 
          echo '</td>';
        }
        if($params10x->show_draw) {
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->cnt_draw); 
          echo '</td>';
        }
        if($params10x->show_loss){
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->cnt_lost); 
          echo '</td>';
        }
        if($params10x->show_results){
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, sprintf("%s:%s",$item->sum_matchpart1_result,$item->sum_matchpart2_result)); 
          echo '</td>';
        }
        if($params10x->show_diff){
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->diff_matchpart_results); 
          echo '</td>';
        }
        if($params10x->show_points){
          echo '<td bgcolor="'.$color.'" align="center">'; 
          printf($format, $item->sum_points); 
          if ($table_config['show_negative_points']==1) {
            echo ':'; 
            printf($format, $item->neg_points);
          } 
          echo '</td>';
        }
        echo '</tr>';
        
        $previous_row_empty=0;
        
        $k = 1 - $k;$counter++;$temprank=$item->rank;
      }
      else { //display one row with discontinued sign between fav teams if max row was reached
        if ($previous_row_empty==0) { 
          echo '<tr class="sectiontableentry2"><td align="right" bgcolor="">:&nbsp;</td><td colspan="'.$col_count.'" align="right" bgcolor="">&nbsp;</td></tr>';
          $previous_row_empty=1;
          $k = 1 - $k;
        }
      }
    } //foreach table row
    
    echo '</table>';
    
    //link to full table if number of row was limited
    if($max_team) {
      echo '<table width="100%"><tr><td align="center">';
      echo '<a href="'.sefRelToAbs('index.php?option=com_joomleague&amp;func=showRanking&amp;p='.$project->id.'&amp;Itemid='.$Itemid).'">';
      echo _JL_MODULE_RANKING_TOTAL.'</a></td></tr></table>';
    }
    
    if ($divtext[$i]<>'') echo '</div>';
  } //foreach tabs
  
  // script for tabs display
  if ($params10x->show_multiple_rankings == 1) {
    echo '<script language="javascript" type="text/javascript">';
    if ($params10x->show_ranking_home == 1) echo "dhtml_ranking".$module->id.".cycleTab('tab_ranking_home".$module->id."');";
    if ($params10x->show_ranking_away == 1) echo "dhtml_ranking".$module->id.".cycleTab('tab_ranking_away".$module->id."');";
    if ($params10x->show_ranking_all == 1) echo "dhtml_ranking".$module->id.".cycleTab('tab_ranking_all".$module->id."');";
    echo '</script>';
  }
} 
else {
  echo "No project specified in configuration or in page url ('&p=XX'), or project not found";
}
?>
