<?php
/*
 * @version $Id$
 * @package Joomleague
 * @subpackage nextmatch
 * @copyright Copyright (C) 2007  JoomLeague
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see _joomleague_license.txt
 *  
**********************************************
JoomLeague Next-Match Extended Module
Copyright (c) 2007 Carsten Khn
**********************************************
This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This header must not be removed. Additional contributions/changes
may be added to this header as long as no information is deleted.
**********************************************

* JL Players birthday
*
* 05/05/2008 - Version 0.093
  
* Module for displaying Players upcoming birthdays  of the favoured
* JoomLeague Team(s) and (if you want to) in  selected Project(s) 
* There are some options for this module, which can be set in the 
* "Parameters" section of the module in Administration.
*

**********************************************
Get the latest version of JoomLeague at:
http://http://www.joomleague.de//
**********************************************
*/
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
global $mosConfig_absolute_path, $mosConfig_live_site;
if(!function_exists('jl_birthday_sort')){
	// snippet taken from http://de3.php.net/manual/en/function.uasort.php
  function jl_birthday_sort ($array, $arguments = array(), $keys = true) {
      
    $code = "\$result=0;";
      
    foreach ($arguments as $argument) {
          
      $field = substr($argument, 2, strlen($argument));
          
      $type = $argument[0];
          
      $order = $argument[1];

      $code .= "if (!Is_Numeric(\$result) || \$result == 0) ";
              
      if (strtolower($type) == "n") $code .= $order == "-" ? "\$result = (intval(\$a['{$field}']) > intval(\$b['{$field}']) ? -1 : (intval(\$a['{$field}']) < intval(\$b['{$field}']) ? 1 : 0));" : "\$result = (intval(\$a['{$field}']) > intval(\$b['{$field}']) ? 1 : (intval(\$a['{$field}']) < intval(\$b['{$field}']) ? -1 : 0));";
          
      else $code .= $order == "-" ? "\$result = strcoll(\$a['{$field}'], \$b['{$field}']) * -1;" : "\$result = strcoll(\$a['{$field}'], \$b['{$field}']);";
    }
           
    $code .= "return \$result;";
  
    $compare = create_function('$a, $b', $code);
       
    if ($keys) uasort($array, $compare);
       
    else usort($array, $compare);
          
    return $array;
  }

}


$params = mosParseParams( $module->params );

$p = trim($params->project);
$usedteams='';
$birthdaytext='';
$players = array();
$crew = array();
if ($params->use_fav==1) {
	$query='SELECT fav_team FROM #__joomleague';
	if ($p!='' && $p>0) $query.= ' WHERE id IN ('.$p.')';
	$database->setQuery($query);
	$temp=$database->loadResultArray();
	if (count($temp)>0) {
		$usedteams=join(',', array_filter($temp));
	}

}
else {
	$usedteams = ($params->teams != '') ? $params->teams : '';
}

$dateformat = "DATE_FORMAT(p.birthday,'%Y-%m-%d') AS date_of_birth";
if ($params->use_which <= 1) {
  $query="SELECT p.id, p.birthday, p.firstname, p.lastname, p.default_picture, p.nation,pt.picture AS picture,
  DATE_FORMAT(p.birthday, '%m-%d')AS daymonth,
  YEAR( CURRENT_DATE( ) ) as year,
  YEAR( CURRENT_DATE( ) ) - YEAR( p.birthday ) AS age,
  $dateformat, pt.team_id, pt.project_id,pt.id AS ptid,
  (TO_DAYS(DATE_ADD(p.birthday, INTERVAL 
	(YEAR(CURDATE()) - YEAR(p.birthday) +
	IF(DATE_FORMAT(CURDATE(), '%m%d') > 
	DATE_FORMAT(p.birthday, '%m%d'), 1, 0))
	YEAR)) - TO_DAYS( CURDATE())+0) AS days_to_birthday,
	'showPlayer' AS func_to_call,
	'pid' AS id_to_append
  FROM #__joomleague_players AS p, #__joomleague_playertool AS pt
  WHERE pt.player_id = p.id  AND p.birthday != '0000-00-00' AND 
  DATE_FORMAT(p.birthday, '%m%d') >= DATE_FORMAT(CURDATE(), '%m%d')";
  if ($usedteams!='') $query .= " AND pt.team_id IN (".$usedteams.")";
  if ($p!='' && $p>0) $query .= " AND pt.project_id IN (".$p.")"; 
  $query .= " GROUP BY p.id";
  if (intval($params->maxdays)>0) { $query .= " HAVING
	  days_to_birthday <= ".intval($params->maxdays)." OR
	  days_to_birthday >= (DAYOFYEAR(DATE_FORMAT(CURDATE(), '%Y-12-31')) - ".intval($params->maxdays).")";
  }
  $query .= " ORDER BY days_to_birthday ASC
   LIMIT ".$params->limit;
  $database->setQuery($query);
  $players=$database->loadAssocList();
}
if ($params->use_which == 2 || $params->use_which == 0) {
	$query="SELECT p.id, p.birthday, p.firstname, p.lastname, p.default_picture, p.nation,crew.picture AS picture,
  DATE_FORMAT(p.birthday, '%m-%d')AS daymonth,
  YEAR( CURRENT_DATE( ) ) as year,
  YEAR( CURRENT_DATE( ) ) - YEAR( p.birthday ) AS age,
  $dateformat, crew.projectteam_id, crew.teamstaff_id AS tsid,
  (TO_DAYS(DATE_ADD(p.birthday, INTERVAL 
	(YEAR(CURDATE()) - YEAR(p.birthday) +
	IF(DATE_FORMAT(CURDATE(), '%m%d') > 
	DATE_FORMAT(p.birthday, '%m%d'), 1, 0))
	YEAR)) - TO_DAYS( CURDATE())+0) AS days_to_birthday,
	tt.project_id,
	'showTeamstaff' AS func_to_call,
	'tsid' AS id_to_append
  FROM #__joomleague_players AS p, #__joomleague_teamstaff_project AS crew, #__joomleague_team_joomleague tt
  WHERE crew.person_id = p.id AND p.birthday != '0000-00-00' AND 
  DATE_FORMAT(p.birthday, '%m%d') >= DATE_FORMAT(CURDATE(), '%m%d')";
  if ($usedteams!='') $query .= " AND tt.team_id IN (".$usedteams.")";
  if ($p!='' && $p>0) $query .= " AND tt.project_id IN (".$p.")"; 
  $query .= " GROUP BY p.id";
  if (intval($params->maxdays)>0) { $query .= " HAVING
	  days_to_birthday <= ".intval($params->maxdays)." OR
	  days_to_birthday >= (DAYOFYEAR(DATE_FORMAT(CURDATE(), '%Y-12-31')) - ".intval($params->maxdays).")";
  }
  $query .= " ORDER BY days_to_birthday ASC
   LIMIT ".$params->limit;
  $database->setQuery($query);
  $crew=$database->loadAssocList();

}
$persons = array_merge($players, $crew);

$persons = jl_birthday_sort($persons, array("n+days_to_birthday", "n".$params->sort_order."age"), false);
$k=0;
$counter=0;
?><table cellspacing="0" cellpadding="0" border="0" width="100%"><?php
if(count($persons) > 0) {
foreach ($persons AS $player) {
	if ($counter == intval($params->limit)) break;
	$class = ($k == 0)? $params->sectiontableentry1 : $params->sectiontableentry2;

	$thispic = 'components/com_joomleague/images/placeholders/placeholder_150.png';
	if ($player['firstname'] == '') $usedname = htmlentities($player['lastname']);
	elseif ($player['lastname'] == '') $usedname = htmlentities($player['firstname']);
	else {
		$usedname = str_replace('%FIRST%', htmlentities($player['firstname']), htmlentities(trim($params->name_format)));
		$usedname = str_replace('%LAST%', htmlentities($player['lastname']), $usedname);
	}
	if ($params->link_player==1) {
		$url = 'index.php?option=com_joomleague&amp;func='.$player['func_to_call'].'&amp;pid='.$player['id'];
		if (isset($player['tsid'])) $url .= '&amp;tsid='.$player['tsid'];
		$url .= '&amp;p='.$player['project_id'].'&amp;Itemid='.$params->Itemid;
		
		$showname = '<a href="'.sefRelToAbs($url).'">'.$usedname.'</a>';
	}
		
		
		
	else $showname = $usedname;
?>
		<tr class="<?php echo $params->heading_style;?>">
			<td style="text-align:center;">
				<?php echo $showname;?>
			</td>
		</tr>
		<tr class="<?php echo $class;?>">
			<td style="text-align:center;">
			<?php
				if ($params->show_picture==1) { 
					if (file_exists($mosConfig_absolute_path.'/'.$player['picture'])&&$player['picture']!='') {
						$thispic = $player['picture'];
					}
					elseif (file_exists($mosConfig_absolute_path.'/'.$player['default_picture'])&&$player['default_picture']!='') {
						$thispic = $player['default_picture'];
					}
					echo '<img src="'.$mosConfig_live_site.'/'.$thispic.'" alt="'.$usedname.'" title="'.$usedname.'"';
					if ($params->picture_width != '') echo ' width="'.$params->picture_width.'"';
					echo ' /><br />';

			}
			switch ($player['days_to_birthday']) {
			  case 0: $whenmessage = $params->todaymessage;break;
			  case 1: $whenmessage = $params->tomorrowmessage;break;
			  default: $whenmessage = str_replace('%DAYS_TO%', $player['days_to_birthday'], trim($params->futuremessage));break;
			}
			$birthdaytext = htmlentities(trim($params->birthdaytext));
			$dayformat = htmlentities(trim($params->dayformat));
			$birthdayformat = htmlentities(trim($params->birthdayformat));
			$birthdaytext = str_replace('%WHEN%', $whenmessage, $birthdaytext);
			$birthdaytext = str_replace('%AGE%', $player['age'], $birthdaytext);
			$birthdaytext = str_replace('%DATE%', strftime($dayformat, strtotime($player['year'].'-'.$player['daymonth'])), $birthdaytext);
			$birthdaytext = str_replace('%DATE_OF_BIRTH%', strftime($birthdayformat, strtotime($player['date_of_birth'])), $birthdaytext);
			$birthdaytext = str_replace('%BR%', '<br />', $birthdaytext);
			$birthdaytext = str_replace('%BOLD%', '<b>', $birthdaytext);
			$birthdaytext = str_replace('%BOLDEND%', '</b>', $birthdaytext);
			echo $birthdaytext;
			?>
			</td>
		</tr>
<?php
$k = 1 - $k;
$counter++;
}
}
else echo '<tr><td style="text-align:center;">'.str_replace('%DAYS%', $params->maxdays, htmlentities(trim($params->not_found_text))).'</td></tr>';
?>
	</table>
